<template>
  <div class="header_top">
    <div class="header_top-inner-wrapper">
      <div class="header_top-inner flex flex-between">
        <div class="header_left flex flex-middle">
          <img
            v-show="isDemo"
            class="logo"
            src="~/static/icons/logo_demo.png"
            alt="">
          <img
            v-show="!isDemo"
            class="logo"
            src="~/static/icons/logo.svg"
            alt="">
        </div>
        <div
          class="flex flex-between"
          v-if="isAuth">
          <div class="header_center flex flex-middle">
            <div
              class="header_center-deposit"
              :class="isDemo ? 'header_center-deposit-demo': 'header_center-deposit-real'">
              <img
                class="header_center-icon"
                :src="isDemo ? '/common/EOS_demo.svg' : '/common/EOS_live.svg'"
                alt="">
              <span class="text-bold">{{balance}}</span>
            </div>
          </div>
          <div class="header_right flex flex-middle flex-between">
            <Btn
              square
              @click="openDeposit">
              {{$t('header.deposit')}}
            </Btn>

            <!--check it without inline styles!-->
            <Btn
              plain
              style="padding-left: 20px; padding-right: 10px;"
              @click="showMenu ? openMenu(false) : openMenu()">
              <i class="i-icon-more i-deg90 color-icon"></i>
            </Btn>
          </div>
        </div>
        <div
          v-else
          class="flex flex-between">
          <div class="header_center flex flex-middle">
            <LangDropdown></LangDropdown>
          </div>
          <Btn
            square
            v-if="blockedByPincode"
            @click="logout">
            {{$t('header.menu.logOut')}}
          </Btn>
          <Btn
            square
            v-else
            :disabled="showSignIn"
            @click="showAuth">
            {{$t('header.playNow')}}
          </Btn>
        </div>
      </div>
    </div>
    <transition :name="animationMenu">
      <SignIn
        v-if="showSignIn"
        @close="showAuth(false)"></SignIn>
    </transition>
    <transition :name="animationMenu">
      <TheMenu
        v-if="showMenu"
        @changePage="changePage"
        @close="openMenu(false)"></TheMenu>
    </transition>
    <transition
      :name="animationMenu"
      @after-enter="$trigger('deposit:opened')">
      <Deposit
        v-if="showDeposit"
        @close="openDeposit(false)"
        @closeAll="closeAll"></Deposit>
    </transition>
    <transition :name="animationMenu">
      <Profile
        v-if="showProfile"
        @close="openProfile(false)"
        @closeAll="closeAll"></Profile>
    </transition>
  </div>
</template>

<script>
  import Btn from '~/components/UI/Btn';
  import TheMenu from './TheMenu';
  import LangDropdown from './LangDropdown';
  import SignIn from '~/components/signIn/';
  import Deposit from '~/components/deposit';

  export default {
    name: "TheHeader_top",
    data() {
      return {
        showSignIn: false,
        showDeposit: false,
        showProfile: false,
        animationMenu: 'slideTo-left'
      }
    },
    components: {
      Btn,
      SignIn,
      Deposit,
      Profile: () => import('~/components/profile'),
      TheMenu,
      LangDropdown
    },
    computed: {
      blockedByPincode() {
        return !this.$store.state.pincode.controls;
      },
      isDemo() {
        return this.$store.state.common.demo;
      },
      isAuth() {
        return this.$store.state.user.isAuth;
      },
      passedSteps() {
        return this.$store.state.signIn.passed;
      },
      balance() {
        return Math.floor(this.$store.state.wallet.balance * 100) / 100;
      },
      showMenu: {
        get() {
          return this.$store.state.common.showingMenu;
        },
        set(val) {
          this.$store.commit('common/SET_SHOW_MENU', val);
        }
      }
    },
    events: {
      'profile:show': function() {
        this.openProfile(true);
      },
      'deposit:show': function() {
        this.openDeposit();
      }
    },
    methods: {
      logout() {
        this.$store.dispatch('user/logout');
        this.$store.commit('pincode/SET_SHOW_PINCODE', {controls: true, show: false});
      },
      openMenu(show = true, closeAll = false) {
        if (closeAll) this.closeAll();
        show ? this.animationMenu = 'slideTo-left' : this.animationMenu = 'slideTo-right';
        this.$nextTick(_ => {
          this.showMenu = show;
          if (show) {
            this.$emit('overlay', true);
          } else {
            this.$emit('overlay', false);
          }
        });
      },
      openDeposit(show = true) {
        if (show && this.isDemo) {
          this.openMenu(false);
          this.$root.$refs['footerModals'].showComponent('');
          this.$root.$refs['history'].showFullHistory(false);
          this.$store.commit('gameDetails/SET_SHOWING', false);
          return this.$root.$refs['header_bottom'].changeNetwork({showDeposit: true});
        }
        if (show) {
          this.$emit('overlay', true);
        }
        show ? this.animationMenu = 'slideTo-left' : this.animationMenu = 'slideTo-right';
        this.$nextTick(_ => {
          this.showDeposit = show;
          if (!show) {
            this.$emit('overlay', false);
          }
        });
      },
      showAuth(show = true) {
        this.ga('play');
        show ? this.animationMenu = 'slideTo-left' : this.animationMenu = 'slideTo-right';
        this.showSignIn = show;
      },
      closeAll() {
        this.openMenu(false);
        this.openDeposit(false);
        this.showAuth(false);
        this.openProfile(false);
        this.$emit('overlay', false);
      },
      openProfile(show = true) {
        show ? this.animationMenu = 'slideTo-left' : this.animationMenu = 'slideTo-right';
        this.$nextTick(_ => {
          this.showProfile = show;
        });
      },
      openPin(show = true) {
        this.$store.commit('pincode/SET_SHOW_PINCODE', {show, controls: true});
      },
      changePage(label) {
        switch (label) {
          case 'Deposit': {
            this.openDeposit();
            break;
          }
          case 'Profile': {
            this.openProfile();
            break;
          }
          case 'Commissions': {
            this.$emit('overlay', false);
            this.$root.$refs['history'].showFullHistory().then(_ => {
              this.$root.$refs['history'].$refs['fullHistory'].changeComponent('commissions')
            });
            break;
          }
          case 'Promo materials': {
            this.$emit('overlay', false);
            this.$root.$refs['history'].showFullHistory().then(_ => {
              this.$root.$refs['history'].$refs['fullHistory'].changeComponent('advMaterials')
            });
            break;
          }
          case 'Game Stats': {
            this.$emit('overlay', false);
            this.$root.$refs['history'].showFullHistory().then(_ => {
              this.$root.$refs['history'].$refs['fullHistory'].changeComponent('history')
            });
            break;
          }
          case 'Champions': {
            this.$emit('overlay', false);
            this.$root.$refs['history'].showFullHistory().then(_ => {
              this.$root.$refs['history'].$refs['fullHistory'].changeComponent('champions')
            });
            break;
          }
          case 'Set pin': {
            this.openPin();
            break;
          }
        }
      },
      async checkBonus() {
        this.$trigger('checkBonus');
      }
    },
    watch: {
      'isAuth': function () {
        if (this.isAuth && this.passedSteps['step2']) {
          this.showAuth(false);
          this.$store.dispatch('game/fetchGames');
        }
        //console.log('header top isAuth - ', this.isAuth);
        if (this.isAuth) {
          this.checkBonus();
          this.$store.dispatch('user/addUserInfo');
          this.$store.dispatch('wallet/startCheckingAccount');
          if(!localStorage.getItem("app.16bit_helpPage")) {
            this.$trigger('helppage:show');
          }
        }
      }
    },
    mounted() {
      this.$root.$refs['headerTop'] = this;
    },
    created() {
      this.$store.dispatch('deposit/fetch');
    }
  }
</script>
